% interpolation P1 2D
% renvoie les coordonnees barycentriques de points z en tant qu'elements
% d'un certain triangle de t, p etant les points lies a t.
function interpol=interpolationP12D(z,p,t)

disp('Interpolation barycentrique');
nz=size(z,2);
np=size(p,2);

% liste des triangles t (associes a p) contenant les points z
T = tsearch(p(1,:),p(2,:),t',z(1,:),z(2,:));

%% cette fonction tsearch marche tres vite mais file parfois des Nan alors
%% que ca devrait pas...il faut donc corriger

boulettes=isnan(T);
T(boulettes) = tsearch(p(1,:),p(2,:),t',z(1,boulettes)+10*eps,z(2,boulettes)+10*eps);

% liste des sommets
S1=p(:,t(1,T));
S2=p(:,t(2,T));
S3=p(:,t(3,T));
% (S1-S3) orthogonal et (S2-S3) orthogonal
S1_S3_ort=[-S1(2,:)+S3(2,:);S1(1,:)-S3(1,:)];
S2_S3_ort=[-S2(2,:)+S3(2,:);S2(1,:)-S3(1,:)]; % l'orthogonal est ici pris précisément au sens [-y;x]
% liste des déterminants
det=sum(S1_S3_ort.*(S2-S3));

alpha=sum(-(z-S3).*S2_S3_ort)./det;
alpha(alpha>1)=1;
alpha(alpha<0)=0;
beta =sum( (z-S3).*S1_S3_ort)./det;
beta(beta>1)=1;
beta(beta<0)=0;
gamma=ones(1,nz)-alpha-beta;

interpol=sparse(1:nz,t(1,T)',alpha,nz,np,nz)+sparse(1:nz,t(2,T)',beta,nz,np,nz)+sparse(1:nz,t(3,T)',gamma,nz,np,nz);
% procedure validee par :
% z2=interpol*p';
% plot(z2(:,1),z2(:,2),'or',z(1,:),z(2,:),'+g');

