% t = line_search(f, x, t, d, methode)
% f = function handle qui renvoie [ f(x), gradf(x) ]
% t = initial guess
% d = direction de descente
% methode = {dichotomie}, 'wolfe'
function t = line_search(f, x, t, d, methode)
% initialisation = -2 alpha(fx -fx(n-1))/ d.gradfx
MAX_ITERATIONS = 10;
M1 = 0.1;
M2 = 0.7;
tL = 0;
tR = 0;
[Q0, Q_PRIME_0] = q(0);

for it = 1:MAX_ITERATIONS
    [qT, qPrimeT] = q(t);
    switch methode
        case 'wolfe'
            if qT <= Q0 + M1*t*Q_PRIME_0 && qPrimeT >= M2*Q_PRIME_0;
                return; 
            end
            if qT > Q0 + M1*t*Q_PRIME_0;
                tR = t; 
            end
            if qT <= Q0 + M1*t*Q_PRIME_0 && qPrimeT < M2*Q_PRIME_0;    
                tL = t; 
            end
        otherwise
            if Q_PRIME_0*qPrimeT <0;
                tR = t;
            else
                tL = t;
                Q_PRIME_0 = qPrimeT;
            end
    end
    if tR==0; t = tL*2; else t = (tL+tR)/2; end
end

% warning('Line search : Max iterations reached')
% fonction q qu'on "minimise"
function [qT, qPrimeT] = q(t)
    if nargout > 1
        [qT, gradF] = f(x+t*d);
        qPrimeT = d'*gradF;
    else
        qT = f(x+t*d);
    end
end
end
