%entree : deux liste de points sous forme de colonnes 2xn1 et 2xn2
%rend la liste telle que p2(p2_to_p1(i)) soit la
%meilleure approximation de p1(i) (parmi les p2).

%on peut d'ailleurs facilement augmenter cette fonction en rajoutant le
%mapping inverse en renvoyant aussi la liste des minimiseurs le long des
%lignes...
function [p2_to_p1]=meilleure_approximation(p1,p2)
        disp('Meilleure approximation');
        n1=size(p1,2);
        n2=size(p2,2);
        %dim=size(p1,1);

        A=repmat(p1,[n2,1]);% [a1 a2 a3... ; a1 a2 a3...; a1 a2 a3; ...]
        B=p2(:);% [b1;b2;b3;...]
        B=repmat(B,[1,n1]);% [b1;b2;b3;...][b1;b2;b3;...][b1;b2;b3;...]...
        %alors A-B a une paire de lignes pour chaque point de B et
        %une colonne pour chaque point de A.
        %Le reshape donne alors une paire de lignes de la forme
        %a1-b1 a1-b2 ... a2-b1 a2-b2 ... a3-b1 a3-b2 ... ...]  
        C=B-A;
        clear A B;
        C=reshape(C,2,n1*n2);
        normes=normv(C,'reels');
        normes=reshape(normes,n2,n1);%remis sous forme de matrice avec une colonne par ai et une ligne par bi
        [minimales,indices]=min(normes,[],1);%pour chaque ai on cherche le bi le plus proche : on minimise par colonne
        p2_to_p1=indices(:);
end