% normes=normv(M)
% renvoie la colonne des normes euclidiennes (norme2) de M vue comme une collection de vecteurs
% colonne  : on somme sur la premiere dimension et le retour est donc de
% taille d2*d3*...dn,1 si d1,d2,d3,...,dn sont les dimensions de M.
function normes=normv(M,corps)
if nargin>1 && strcmp(corps,'reels')
    %if strcmp(corps,'reels')
        carre=2*ones(size(M));
        normes=realpow(M,carre);
    %else
    %    normes=abs(M).^2;
    %end
else
    normes=abs(M).^2;
end
normes=sum(normes,1);
normes=realsqrt(normes);
normes=reshape(normes,[],1);
end