% construit une somme de $bosses$ gaussiennes centrées sur $centres$ (qui est une collection de colonnes de points),
% variant de $amplitude$% autour de $constante$ sur l'ensemble des $points$
function surface = vague( points, constante, amplitude, bosses, centres )
surface = constante*ones( size( points, 2 ), 1 );
alpha = 2*(max( points(1,:) )-min( points(1,:) ));
for ib=1:bosses
    centre = [ max( points(1,:) )-min( points(1,:) ) ; 
               max( points(2,:) )-min( points(2,:) ) ].*centres(:,ib)+...
             [ min( points(1,:) ) ; min( points(2,:) ) ];
    surface = surface+exp( -1i*alpha*normv( points-repmat( centre, 1, ...
                      size( points, 2 ) ) ) )*constante*amplitude/bosses;
end
surface = surface(:);