function [x,y]=geometrie(bs,s)
global x1 x2 y1 y2;

nbs=4;
%R=1.5;  %le cote

if nargin==0,
  x=nbs; % number of boundary segments
  return
end

d=[
  0 0 0 0 % start parameter value
  1 1 1 1 % end parameter value
  1 1 1 1 % left hand region
  0 0 0 0 % right hand region
];

bs1=bs(:)';

if find(bs1<1 | bs1>nbs),
  error('Non existent boundary segment number')
end

if nargin==1,
  x=d(:,bs1);
  return
end

x=zeros(size(s));
y=zeros(size(s));
[m,n]=size(bs);
if m==1 && n==1,
  bs=bs*ones(size(s)); % expand bs
elseif m~=size(s,1) || n~=size(s,2),
  error('bs must be scalar or of same size as s');
end

if ~isempty(s),

% boundary segment 1
ii=find(bs==1);
x(ii)=s(ii)*(x1-x2)+x2;
y(ii)=y2;%R;

% boundary segment 2
ii=find(bs==2);
x(ii)=x1;%-R;
y(ii)=s(ii)*(y1-y2)+y2;

% boundary segment 3
ii=find(bs==3);
x(ii)=s(ii)*(x2-x1)+x1;
y(ii)=y1;

% boundary segment 4
ii=find(bs==4);
x(ii)=x2;
y(ii)=s(ii)*(y2-y1)+y1;

end

