% Geometrie variable ayant pour base pour un gros disque
% avec deux indices ca rajoute dedans un disque moyen
% avec trois indices on rajoute une bosse dans le disque moyen
% avec quatre indices on rajoute une seconde bosse hors du disque moyen
% (=> utiliser les quatre indices donne un indice de base non constant avec irregularite non connexe)
% indice1 : grand cercle
% indice2 : moyen cercle
% indice3 : bosse dans le moyen cercle
% indice4 : bosse hors du moyen cercle

%
% induit souvent des geometry error ....
%

function [x,y]=geometrie(bs,s)
global l_p_z globalk bords_observation bords_debut_pml bords_objets zones_a_indice nombre_d_indices;
k=globalk;lambda_par_zone=l_p_z;
%% les valeurs specifiques
bords_observation = [];
bords_debut_pml = [1 2 3 4];
bords_exterieurs = [5 6 7 8];  %inutile mais pour info.

zones_a_indice = 1:nombre_d_indices; %suivant les numeros d'indice
%zone6 = entre l'objet et debut des mpl
%zone7 = entre debut des pml et bord exterieur
bords_objets = 9:8+4*nombre_d_indices;

nbs=8+4*nombre_d_indices;  %nombre total de bords

%grandeurs a=demi rayon horizontal   b=demi rayon vertical   c=centre
% grand cercle
a1=1;
b1=1.2;
c1=[0,0];
%p1=2*pi*sqrt((a1^2+b1^2)/2);
% moyen cercle
a2=0.3;
b2=0.3;
c2=[0.3,0.3];
%p2=2*pi*sqrt((a2^2+b2^2)/2);
% irregularite dans le moyen cercle
a3=0.09;
b3=0.08;
c3=[0.31,0.29];
%p3=2*pi*sqrt((a3^2+b3^2)/2);
% irregularite hors du moyen cercle
a4=0.11;
b4=0.09;
c4=[-0.35,-0.34];
%p4=2*pi*sqrt((a4^2+b4^2)/2);

% les distances
lambda=2*pi/k;
distance_entre_zones=lambda*lambda_par_zone;
%distance_observation=distance_entre_zones+; %distance d'observation (au centre)
%do=2*distance_observation;
distance_pml=distance_entre_zones+max([a1+abs(c1(1)),b1+abs(c1(2))]); %distance de debut des pml (au centre)
dp=2*distance_pml;
distance_max=distance_pml+distance_entre_zones; %distance du bord exterieur du domaine de calcul (au centre)
dm=2*distance_max;

%matrice des bords :
% pml          exterieur    gros_cercle  moyen_cercle  bosse1   bosse2
d=[
  0  0  0  0   0  0  0  0   0 0 0 0      0 0 0 0       0 0 0 0  0 0 0 0 % start parameter value
  dp dp dp dp  dm dm dm dm  1 1 1 1      1 1 1 1       1 1 1 1  1 1 1 1 % end parameter value
  6  6  6  6   7  7  7  7   1 1 1 1      2 2 2 2       3 3 3 3  4 4 4 4 % zone de gauche
  7  7  7  7   0  0  0  0   6 6 6 6      1 1 1 1       2 2 2 2  1 1 1 1 % zone de droite
];
d=d(:,1:nbs);

%% du code pour que ca marche
if nargin==0,
  x=nbs; % number of boundary segments
  return
end

bs1=bs(:)';

if find(bs1<1 | bs1>nbs),
  error('Non existent boundary segment number')
end

if nargin==1,
  x=d(:,bs1);
  return
end

x=zeros(size(s));
y=zeros(size(s));
[m,n]=size(bs);
if m==1 && n==1,
  bs=bs*ones(size(s)); % expand bs
elseif m~=size(s,1) || n~=size(s,2),
  error('bs must be scalar or of same size as s');
end

if ~isempty(s),
    
%% la geometrie    
%
%observation
%




%
%debut des pml
%
% boundary segment 1
ii=find(bs==1);
x(ii)=distance_pml-s(ii);
y(ii)=distance_pml;
% boundary segment 2
ii=find(bs==2);
x(ii)=-distance_pml;
y(ii)=distance_pml-s(ii);
% boundary segment 3
ii=find(bs==3);
x(ii)=-distance_pml+s(ii);
y(ii)=-distance_pml;
% boundary segment 4
ii=find(bs==4);
x(ii)=distance_pml;
y(ii)=-distance_pml+s(ii);

%
%bord exterieur final
%
% boundary segment 5
ii=find(bs==5);
x(ii)=distance_max-s(ii);
y(ii)=distance_max;
% boundary segment 6
ii=find(bs==6);
x(ii)=-distance_max;
y(ii)=distance_max-s(ii);
% boundary segment 7
ii=find(bs==7);
x(ii)=-distance_max+s(ii);
y(ii)=-distance_max;
% boundary segment 8
ii=find(bs==8);
x(ii)=distance_max;
y(ii)=-distance_max+s(ii);

%
%le premier cercle
% 
% boundary segment 1
ii=find(bs==9);
x(ii)=c1(1)+a1*cos((pi/2)*s(ii)-pi);
y(ii)=c1(2)+b1*sin((pi/2)*s(ii)-pi);

% boundary segment 2
ii=find(bs==10);
x(ii)=c1(1)+a1*cos((pi/2)*s(ii)-(pi/2));
y(ii)=c1(2)+b1*sin((pi/2)*s(ii)-(pi/2));

% boundary segment 3
ii=find(bs==11);
x(ii)=c1(1)+a1*cos((pi/2)*s(ii));
y(ii)=c1(2)+b1*sin((pi/2)*s(ii));

% boundary segment 4
ii=find(bs==12);
x(ii)=c1(1)+a1*cos((pi/2)*s(ii)-(3*pi/2));
y(ii)=c1(2)+b1*sin((pi/2)*s(ii)-(3*pi/2));




%
%le deuxieme cercle
%   
% boundary segment 1
ii=find(bs==13);
x(ii)=c2(1)+a2*cos((pi/2)*s(ii)-pi);
y(ii)=c2(2)+b2*sin((pi/2)*s(ii)-pi);

% boundary segment 2
ii=find(bs==14);
x(ii)=c2(1)+a2*cos((pi/2)*s(ii)-(pi/2));
y(ii)=c2(2)+b2*sin((pi/2)*s(ii)-(pi/2));

% boundary segment 3
ii=find(bs==15);
x(ii)=c2(1)+a2*cos((pi/2)*s(ii));
y(ii)=c2(2)+b2*sin((pi/2)*s(ii));

% boundary segment 4
ii=find(bs==16);
x(ii)=c2(1)+a2*cos((pi/2)*s(ii)-(3*pi/2));
y(ii)=c2(2)+b2*sin((pi/2)*s(ii)-(3*pi/2));



%
%le troisieme cercle
%   
% boundary segment 1
ii=find(bs==17);
x(ii)=c3(1)+a3*cos((pi/2)*s(ii)-pi);
y(ii)=c3(2)+b3*sin((pi/2)*s(ii)-pi);

% boundary segment 2
ii=find(bs==18);
x(ii)=c3(1)+a3*cos((pi/2)*s(ii)-(pi/2));
y(ii)=c3(2)+b3*sin((pi/2)*s(ii)-(pi/2));

% boundary segment 3
ii=find(bs==19);
x(ii)=c3(1)+a3*cos((pi/2)*s(ii));
y(ii)=c3(2)+b3*sin((pi/2)*s(ii));

% boundary segment 4
ii=find(bs==20);
x(ii)=c3(1)+a3*cos((pi/2)*s(ii)-(3*pi/2));
y(ii)=c3(2)+b3*sin((pi/2)*s(ii)-(3*pi/2));



%
%le quatrieme cercle
%   
% boundary segment 1
ii=find(bs==21);
x(ii)=c4(1)+a4*cos((pi/2)*s(ii)-pi);
y(ii)=c4(2)+b4*sin((pi/2)*s(ii)-pi);

% boundary segment 2
ii=find(bs==22);
x(ii)=c4(1)+a4*cos((pi/2)*s(ii)-(pi/2));
y(ii)=c4(2)+b4*sin((pi/2)*s(ii)-(pi/2));

% boundary segment 3
ii=find(bs==23);
x(ii)=c4(1)+a4*cos((pi/2)*s(ii));
y(ii)=c4(2)+b4*sin((pi/2)*s(ii));

% boundary segment 4
ii=find(bs==24);
x(ii)=c4(1)+a4*cos((pi/2)*s(ii)-(3*pi/2));
y(ii)=c4(2)+b4*sin((pi/2)*s(ii)-(3*pi/2));




end