% options.methode = 'somme' ou 'inverse'
% options.operateur = '|W|', '|F1-F0|', 'W' et 'W#'
function [carte, data] = indicatrice_image(u_0, physique, F1, F0, options)
%disp('Indicatrice pseudo-inverse')
%tic

% construction de l'operateur de mesures
[W,demiMasse] = operateur_mesures( F0, F1, physique.nombreOnde, physique.anglesEmissions, physique.anglesMesures, options.operateur);
[U,S,V] = svd(W,'econ');

switch options.methode
    case 'somme' % somme des |<bar u,fi>|^2/si
        ubarPsi = u_0*demiMasse*V; 
        % norme au carr de toutes ces valeurs
        ubarPsi2 = abs(ubarPsi.*conj(ubarPsi)); 
        somme = ubarPsi2*diag(S.^(-1));%sum(ubarPsi2/S,2);
        carte = somme(:).^(-1);
    case 'inverse' % resolution de Wx=u   
        % transpose de la solution de W1/2 x = uBar
        xt = (u_0*demiMasse)/sqrtm(W');%(((u_0*U)/sqrt(S))*V');%
        x2 = sum( abs(conj(xt).*(xt)),2); % norme au carr
        carte = (x2).^(-1); % et surtout pas (1+y) !
end
data =1;
%
%data.time = toc;%['Valeurs propres utilisees : ',num2str(sum(vsAssezGrandes)),' sur ',num2str(nEmissions)];
%options