% plot_Linf4(Liste_inf,k,p,t,points_bord_objet,'on',mesures,emissions)

function [h_map,h_log,h_grad]=plot_Liste_inf(Liste_inf,k,p,t,points_bord_objet,visibilite,mesures,emissions,fleches,N_et_B)%,indice_objet,indice_inclusion,contraste)




%% Dessins
disp('Dessin du resultat')
Liste_inf=Liste_inf(:);

if isempty(fleches)
    fleches=true;
end
if isempty(N_et_B)
    N_et_B=false;
end

%% Echelle de couleurs avec du blanc en bas
h_map=figure('Visible',visibilite);

if N_et_B
    borne = 1.3;
    grey = (tanh(linspace(borne, -borne, 128)/tanh(borne))+1)/2;
    grey=[grey(:) grey(:) grey(:)];
    couleurs=grey;
else
    couleurs=jet;
    %couleurs=couleurs(end:-1:1,:);
    niveau_0=10;
    %couleur_0=couleurs(niveau_0,:);
    couleurs(1:niveau_0,:)=linspacev([1 1 1],couleurs(niveau_0,:),niveau_0)';
    %[linspace(1,couleur_0(1),niveau_0) ; linspace(1,couleur_0(2),niveau_0) ; linspace(1,couleur_0(3),niveau_0)]'; 
end
niveaux=6;

%% Valeurs
xmin=min(points_bord_objet(1,:));
xmax=max(points_bord_objet(1,:));
ymin=min(points_bord_objet(2,:));
ymax=max(points_bord_objet(2,:));

bbox=[xmin xmax ymin ymax];
centre=[bbox(1)+bbox(2);bbox(3)+bbox(4)]/2;
alpha=1.5;
bbox=alpha*[xmin xmax ymin ymax]+(1-alpha)*[centre(1) centre(1) centre(2) centre(2)];


rayon=min(abs(bbox(1)-bbox(2)),abs(bbox(3)-bbox(4)))/2;


a_mes=linspace(mesures(1),mesures(end),100);
a_emi=linspace(emissions(1),emissions(end),100);

mesures=[cos(a_mes);sin(a_mes)];
emissions=[cos(a_emi);sin(a_emi)];

emissions_cadrees=emissions*rayon*1.2+repmat(centre,1,size(emissions,2));
emission_centrale=emissions_cadrees(:,floor((size(emissions,2)-1)/2));

mesures_cadrees=mesures*rayon*1.3+repmat(centre,1,size(mesures,2));
mesure_centrale=mesures_cadrees(:,floor((size(mesures,2)-1)/2));


%bbox=bbox*1.3;


%% carte des resultats
%pdeplot(p,[],t,'xydata',Liste_inf,'contour','off','colormap','jet','colorbar','on');
pdeplot(p,[],t,'xydata',Liste_inf,'xystyle','interp','contour','on','colormap',couleurs,'colorbar','on','levels',niveaux);

bordure_objet;
arcs_de_mesures;
axis(bbox);
set(gca,'FontSize',20);
axis equal 

%% carte des log
h_log=0;
% h_log=figure('Visible',visibilite);
% pdeplot(p,[],t,'xydata',20*log(Liste_inf),'xystyle','interp','contour','on','colormap',couleurs,'colorbar','on','levels',niveaux);
% 
% bordure_objet;
% arcs_de_mesures;
% axis(bbox);
% axis equal 

%% carte des gradients
h_grad=0;
% h_grad=figure('Visible',visibilite);
% [ux,uy]=pdegrad(p,t,Liste_inf);
% ng=sqrt(ux.^2+uy.^2);
% %pdeplot(p,[],t,'xydata',ng,'xystyle','off','contour','on','colormap',couleurs,'colorbar','on');
% pdeplot(p,[],t,'xydata',ng,'contour','off','colormap',couleurs,'colorbar','on','levels',niveaux);
% 
% bordure_objet;
% arcs_de_mesures;
% axis(bbox);
% axis equal 

%% macros
function bordure_objet
hold on
plot(points_bord_objet(1,:),points_bord_objet(2,:),'ok','linewidth',0.5,'MarkerSize',2,'MarkerFaceColor','k')
hold off
end

function arcs_de_mesures
    if fleches
hold on
% for ie=1:size(emissions,2)
%     emission=emissions_cadrees(:,ie);
%     arrow(emission,emission*(1-1/6),'Width',0.5,'Length',8);
% end
% for ie=1:size(mesures,2)
%     mesure=mesures_cadrees(:,ie);
%     arrow(mesure,mesure*(1+1/6),'Width',0.5,'Length',8);
% end

plot(emissions_cadrees(1,:),emissions_cadrees(2,:),'Color',[.1 .1 .1]*3,'Linewidth',2.86);
plot(mesures_cadrees(1,:),mesures_cadrees(2,:),'Color',[.1 .1 .1]*3,'Linewidth',2.86);%k/2.1
arrow([emission_centrale(1);emission_centrale(2)],[emission_centrale(1);emission_centrale(2)]-[emission_centrale(1)/6;emission_centrale(2)/6],'Width',interp1([.1 .6 6 16 25],[.1 .8 2 3 3.1],k,'cubic'),'Length',interp1([.1 .6 6 16 25],[.8 4 12 20 22],k,'cubic'));
arrow([mesure_centrale(1);mesure_centrale(2)],[mesure_centrale(1);mesure_centrale(2)]+[mesure_centrale(1)/6;mesure_centrale(2)/6],'Width',interp1([.1 .6 6 16 25],[.1 .8 2 3 3.1],k,'cubic'),'Length',interp1([.1 .6 6 16 25],[.8 4 12 20 22],k,'cubic'));%
hold off;
    end
end

end