function save_rendu_inclusion(methode,carte,k,p2,t2,points_objet,n_x,n_x2,p,t,objet,inclusion,emissions,mesures,bruitage,geometrie,script,fleches,N_et_B)
disp('Dessins et sauvegarde')



%% dessins
[h7,h1,h6]=plot_Linf5(carte,k,p2,t2,points_objet,'off',mesures,emissions,fleches,N_et_B);
h2=figure('Visible','off');
pdeplot(p,[],t(:,objet),'xydata',real(n_x(objet)),'xystyle','flat','contour',...
'on','levels',linspace(min(real(n_x(objet))),max(real(n_x(objet))),10),'colorbar','on','colormap',jet);
axis equal 
h3=figure('Visible','off');
pdeplot(p,[],t(:,objet),'xydata',imag(n_x(objet)),'xystyle','flat','contour',...
'on','levels',linspace(min(imag(n_x(objet))),max(imag(n_x(objet))),10),'colorbar','on','colormap',jet); 
axis equal 


h4=figure('Visible','off');
pdeplot(p,[],t(:,objet),'xydata',real(n_x2(objet)),'xystyle','flat','contour',...
'on','levels',linspace(min(real(n_x(objet))),max(real(n_x(objet))),10),'colorbar','on','colormap',jet); 
axis equal 
h5=figure('Visible','off');
pdeplot(p,[],t(:,objet),'xydata',imag(n_x2(objet)),'xystyle','flat','contour',...
'on','levels',linspace(min(imag(n_x(objet))),max(imag(n_x(objet))),10),'colorbar','on','colormap',jet);
axis equal 
drawnow;
%% sauvegardes des images

mr0= min(real(n_x(objet)));
Mr0= max(real(n_x(objet)));
mi0= min(imag(n_x(objet)));
Mi0= max(imag(n_x(objet)));

mr1= min(real(n_x2(inclusion)));
Mr1= max(real(n_x2(inclusion)));
mi1= min(imag(n_x2(inclusion)));
Mi1= max(imag(n_x2(inclusion)));

e1=emissions(1)/pi;
e2=emissions(end)/pi;
m1=mesures(1)/pi;
m2=mesures(end)/pi;

A=aires_triangles(p,t);
n01=n_x2(objet & ~inclusion)*A(objet & ~inclusion)/sum(A(objet & ~inclusion)); %n0 moyen, hors inclusion
n02=n_x(objet & ~inclusion)*A(objet & ~inclusion)/sum(A(objet & ~inclusion)); % n0 tilde moyen, hors inclusion


switch methode
    case 1
        methode_str='inf W sharp';
    case 2
        methode_str='spectrale W sharp';
    case 3
        methode_str='inf abs W';
    case 4
        methode_str='spectrale abs W';
end

prefixe=['/DATA/Rendus_Matlab/Reconstruction_inclusion/',datestr(now,29),'-',datestr(now,15),'/'];
% prefixe=strcat('/DATA/Rendus_Matlab/Reconstruction_inclusion/',datestr(now,29),'-',datestr(now,15),'_:_',...
%     num2str(size(emissions,2),3),'_emissions_sur_',num2str(e1,3),'-',num2str(e2,3),'_',...
%     num2str(size(mesures,2),3),'_mesures_sur_',num2str(m1,3),'-',num2str(m2,3),'_avec_',...
%     num2str(bruitage,3),'_de_bruit_n0_',num2str(mr0,3),'-',num2str(Mr0,3),'+i',num2str(mi0,3),'-',num2str(Mi0,3),...
%     '_n1_',num2str(mr1,3),'-',num2str(Mr1,3),'+i',num2str(mi1,3),'-',num2str(Mi1,3),'_k',num2str(k,3),'/');
mkdir(prefixe);


fileID=fopen([prefixe,'parametres.txt'],'w+');

fprintf(fileID,['k=',num2str(k,3),'\n']);
fprintf(fileID,[num2str(size(emissions,2),3),' emissions sur [',num2str(e1,3),'pi, ',num2str(e2,3),'pi]\n']);
fprintf(fileID,[num2str(size(mesures,2),3),' mesures sur [',num2str(m1,3),'pi, ',num2str(m2,3),'pi]\n']);
fprintf(fileID,['bruit : ',num2str(bruitage*100,3),'%%\n']);
fprintf(fileID,['n0 dans l''objet est dans [',num2str(mr0,3),', ',num2str(Mr0,3),']+i[',num2str(mi0,3),', ',num2str(Mi0,3),']\n']);
fprintf(fileID,['n0 moyen hors inclusion = ',num2str(n02,3),'\n']);
fprintf(fileID,['n1 dans l''inclusion est dans [',num2str(mr1,3),', ',num2str(Mr1,3),']+i[',num2str(mi1,3),', ',num2str(Mi1,3),']\n']);
fprintf(fileID,['n1 moyen hors inclusion = ',num2str(n01,3),'\n']);
fprintf(fileID,['methode de reconstruction : ',methode_str]);

fclose(fileID);




saveas(h1,strcat(prefixe,'carte_20log'),'jpg');
saveas(h1,strcat(prefixe,'carte_20log'),'pdf');
close(h1);
saveas(h2,strcat(prefixe,'indice_d_origine_reel'),'jpg');
saveas(h2,strcat(prefixe,'indice_d_origine_reel'),'pdf');
close(h2);
saveas(h3,strcat(prefixe,'indice_d_origine_imag'),'jpg');
saveas(h3,strcat(prefixe,'indice_d_origine_imag'),'pdf');
close(h3);
saveas(h4,strcat(prefixe,'indice_perturbe_reel'),'jpg');
saveas(h4,strcat(prefixe,'indice_perturbe_reel'),'pdf');
close(h4);
saveas(h5,strcat(prefixe,'indice_perturbe_imag'),'jpg');
saveas(h5,strcat(prefixe,'indice_perturbe_imag'),'pdf');
close(h5);
saveas(h6,strcat(prefixe,'grad'),'jpg');
saveas(h6,strcat(prefixe,'grad'),'pdf');
close(h6);
saveas(h7,strcat(prefixe,'carte'),'jpg');
saveas(h7,strcat(prefixe,'carte'),'pdf');
close(h7);
drawnow;
%% recadrage des pdfs, toujours raté par matlab
pdfs=dir(strcat(prefixe,'*.pdf'));
for ipdf=1:size(pdfs,1)
    pdf=strcat(prefixe,pdfs(ipdf).name);
    unix(['~/pdfcrop.pl ',pdf,' ',pdf,' --clip --margins ''-55 -30 -60 -30''']);
end
%% sauvegarde des paramètres
copyfile(['/udd/deri/ygrisel/Documents/Matlab/Scripts/',script,'.m'],[prefixe,'script.m']);
copyfile(['/udd/deri/ygrisel/Documents/Matlab/Geometries/',geometrie,'.m'],[prefixe,'geometrie.m']);
disp('Fin de la sauvegarde')
