% options.lambdaParZone
% options.maillesParLambda
% options.dessins
% geometrie
%
% maillage.points
% maillage.triangles
% maillage.pointsObjets
% maillage.boitePML
% maillage.indice
function [maillage] = maillage_diffracteur(k, indices, geometrie, options)
global l_p_z globalk bords_observation bords_debut_pml bords_dirichlet bords_objets zones_a_indice nombre_d_indices;
if ~isfield(options, 'lambdaParZone'); options.lambdaParZone = 1; end
if ~isfield(options, 'maillesParLambda'); options.maillesParLambda = 12; end
if ~isfield(options, 'dessins'); options.dessins = false; end
%% passage des valeurs globales
l_p_z=options.lambdaParZone;
globalk=k;
nombre_d_indices=length(indices);

%% maillage
lambda=2*pi/k;
h=lambda/options.maillesParLambda;
[p,e,t]=initmesh(geometrie,'Hmax',h,'Jiggle','on');
if options.dessins
    figure;pdegplot(geometrie);
    title('Geometrie');
    figure;pdemesh(p,e,t);
    title('Maillage');
end

%% points de comparaison
points_objet=[];
for ib=1:size(bords_objets,2)
    e_bord=e(1:2,e(5,:)==bords_objets(ib));
    for ie=1:size(e_bord,2)
        points_objet=[points_objet,p(:,e_bord(:,ie)),[NaN;NaN]]; %#ok<AGROW>
    end
end

%% indice de base
n_x=ones(1,size(t,2));
if size(zones_a_indice,2)~=size(indices,2)
    error('le nombre d''indices ne correspond pas au nombre de zones a indicer');
end
for ik=1:size(zones_a_indice,2)
    n_x(t(4,:)==zones_a_indice(ik))=indices(ik);
end

%% delimitation des pml
bpml=[];
for bk=1:size(bords_debut_pml,2)
    bpml=[bpml,e(1,e(5,:)==bords_debut_pml(bk))]; %#ok<AGROW>
end
if ~isempty(bpml)
    bb_pml=zeros(4,1);
    bb_pml(1)=min(p(1,bpml));
    bb_pml(2)=max(p(1,bpml));
    bb_pml(3)=min(p(2,bpml));
    bb_pml(4)=max(p(2,bpml));
else
    bb_pml=[];
end

maillage.points = p;
maillage.triangles = t(1:3,:);
maillage.pointsObjets = points_objet;
maillage.boitePML = bb_pml;
maillage.indice = n_x;

maillage.D = maillage.indice~=1;
% maillage.airesT = aires_triangles( maillage.points, maillage.triangles(:,maillage.D) );
% maillage.masseD = spdiags( maillage.airesT, 0, nnz( maillage.D ),...
%                            nnz( maillage.D ) );