% assemblage des matrices teslles que    Mtilde U = -Mq h,
% le parametre n étant constant par triangle.
% u est alors solution de (delta +k²n)u = -k²(n-1)h
% avec des pml rectangulaires bornees par bb_pml(2)/max bb_pml(4)/bb_pml(3)
function [Mq,LM,UM,PM,QM,RM]=assemblage_2(points,triangles,n_x,nombre_d_onde,bb_pml)
p=points;
t=triangles;
k=nombre_d_onde;
lambda=2*pi/k;
Epsilon=lambda;
alpha=-3*log(1e-4)/Epsilon^3; %parametre de décroissance dans les pml
nt=size(t,2);
np=size(p,2);
%disp('Assemblage des matrices')

%% Aires des triangles
T=aires_triangles(p,t).';
%% Gradients
%DET=(x1.*y2)-(x1.*y3)-(x2.*y1)+(x2.*y3)+(x3.*y1)-(x3.*y2);
gradFi1=[(p(2,t(2,:))-p(2,t(3,:)));(-p(1,t(2,:))+p(1,t(3,:)))];
gradFi2=[(-p(2,t(1,:))+p(2,t(3,:)));(p(1,t(1,:))-p(1,t(3,:)))];
gradFi3=[(p(2,t(1,:))-p(2,t(2,:)));(-p(1,t(1,:))+p(1,t(2,:)))];

%% Pml
B=  ([p(1,t(1,:));p(2,t(1,:))]+[p(1,t(2,:));p(2,t(2,:))]+[p(1,t(3,:));p(2,t(3,:))])/3;
sx= ones(1,nt);
sy= ones(1,nt);

sx(B(1,:)<bb_pml(1))= 1+1i*alpha/k*(B(1,B(1,:)<bb_pml(1))-bb_pml(1)).^2;
sx(B(1,:)>bb_pml(2))= 1+1i*alpha/k*(B(1,B(1,:)>bb_pml(2))-bb_pml(2)).^2;

sy(B(2,:)<bb_pml(3))= 1+1i*alpha/k*(B(2,B(2,:)<bb_pml(3))-bb_pml(3)).^2;
sy(B(2,:)>bb_pml(4))= 1+1i*alpha/k*(B(2,B(2,:)>bb_pml(4))-bb_pml(4)).^2;

%% Assemblage des matrices
n=n_x.*sx.*sy.*T/12;
Mn=...
     sparse(t(1,:),t(2,:),n   ,np,np,nt)...
    +sparse(t(1,:),t(3,:),n   ,np,np,nt)...
    +sparse(t(2,:),t(3,:),n   ,np,np,nt)...
    +sparse(t(1,:),t(1,:),n   ,np,np,nt)...
    +sparse(t(2,:),t(2,:),n   ,np,np,nt)...
    +sparse(t(3,:),t(3,:),n   ,np,np,nt);
Mn=Mn+Mn.';

R=...
     sparse(t(1,:),t(2,:),(gradFi1(1,:).*gradFi2(1,:).*sy./sx + gradFi1(2,:).*gradFi2(2,:).*sx./sy)./(4*T) ,np,np,nt)...
    +sparse(t(1,:),t(3,:),(gradFi1(1,:).*gradFi3(1,:).*sy./sx + gradFi1(2,:).*gradFi3(2,:).*sx./sy)./(4*T) ,np,np,nt)...
    +sparse(t(2,:),t(3,:),(gradFi2(1,:).*gradFi3(1,:).*sy./sx + gradFi2(2,:).*gradFi3(2,:).*sx./sy)./(4*T) ,np,np,nt)...
    +sparse(t(1,:),t(1,:),(gradFi1(1,:).*gradFi1(1,:).*sy./sx + gradFi1(2,:).*gradFi1(2,:).*sx./sy)./(8*T) ,np,np,nt)...%on met la moitié pour pouvoir faire R=R+R.'
    +sparse(t(2,:),t(2,:),(gradFi2(1,:).*gradFi2(1,:).*sy./sx + gradFi2(2,:).*gradFi2(2,:).*sx./sy)./(8*T) ,np,np,nt)...
    +sparse(t(3,:),t(3,:),(gradFi3(1,:).*gradFi3(1,:).*sy./sx + gradFi3(2,:).*gradFi3(2,:).*sx./sy)./(8*T) ,np,np,nt);
R=R+R.';
q=k^2*(n_x-1).*T/12 ;
Mq=...
    sparse(t(1,:),t(2,:),q  ,np,np,nt)...
   +sparse(t(1,:),t(3,:),q  ,np,np,nt)...
   +sparse(t(2,:),t(3,:),q  ,np,np,nt)...
   +sparse(t(1,:),t(1,:),q  ,np,np,nt)...
   +sparse(t(2,:),t(2,:),q  ,np,np,nt)...
   +sparse(t(3,:),t(3,:),q  ,np,np,nt);
Mq=Mq+Mq.';

Mtilde=(k^2*Mn-R);


%% Factorisation LU
%disp('Factorisation lu')
try
    if  verLessThan('matlab', '7.4')
        [LM,UM,PM,QM]=lu(Mtilde);
        RM=[];
    else
       [LM,UM,PM,QM,RM]=lu(Mtilde);
    end
catch  %#ok<CTCH>
    warning('LU rate : lu incomplet')
    [LM,UM]=luinc(Mtilde,1e-2);
    PM=Mtilde;
    QM=[];RM=[];
end
end