% physique.nombreOnde = k
% physique.anglesMesures = liste d'angles d'evaluation du champ lointain
%
function u_inf = champ_lointain( U, physique, maillage )
%disp('Calcul du champ lointain (méthode volumique)');
t = maillage.triangles( :, maillage.D );

nTriangles = size( t, 2 );
nPoints = size( maillage.points, 2 );

%% calcul de (n-1)x[aire des triangles]/2
aTriangles = aires_triangles( maillage.points, t ).';
q = physique.nombreOnde^2*( maillage.indice( maillage.D )-1 ).*aTriangles/12;

%% matrice éléments finis intégrale de (n-1)*fi*fj
Mq = ...
     sparse( t(1,:), t(2,:), q, nPoints, nPoints, nTriangles )...
    +sparse( t(1,:), t(3,:), q, nPoints, nPoints, nTriangles )...
    +sparse( t(2,:), t(3,:), q, nPoints, nPoints, nTriangles )...
    +sparse( t(1,:), t(1,:), q, nPoints, nPoints, nTriangles )...
    +sparse( t(2,:), t(2,:), q, nPoints, nPoints, nTriangles )...
    +sparse( t(3,:), t(3,:), q, nPoints, nPoints, nTriangles );
Mq = Mq+Mq.';

%% champ lointain  = intégrale de phi^infini*(n-1)*[champ total engendré par n]
u_inf = exp( -1i*physique.nombreOnde*[ cos( physique.anglesMesures )' , ...
                sin( physique.anglesMesures )' ]*maillage.points )*Mq*U;
    