% renvoie le champ lointain de u solution de (Delta+k^2n)u = -k^2(n-1)h
% u_t=u_s+h : le champ total engendré par n
% x_c : les directions d'évaluation du champ lointain
% points et triangles décrivent le maillage sur lequel est donné n_x,
% constant par triangle. On peut donner n_x uniquement dans D, il suffit
% que points et triangles soient cohérents avec.
% k = nombre d'onde
function u_inf=champ_lointain(u_t,x_c,points,triangles,k,n_x)
%disp('Calcul du champ lointain (méthode volumique)');
D= n_x~=1;% domaine D = ensemble des triangles ou l'indice n'est pas 1
t=triangles(:,D);
p=points;

nt=size(t,2);
np=size(p,2);

%% calcul de (n-1)x[aire des triangles]/2
T=aires_triangles(p,t).';
q=k^2*(n_x(D)-1).*T/12;

%% matrice éléments finis intégrale de (n-1)*fi*fj
Mq=...
     sparse(t(1,:),t(2,:),q ,np,np,nt)...
    +sparse(t(1,:),t(3,:),q ,np,np,nt)...
    +sparse(t(2,:),t(3,:),q ,np,np,nt)...
    +sparse(t(1,:),t(1,:),q ,np,np,nt)...
    +sparse(t(2,:),t(2,:),q ,np,np,nt)...
    +sparse(t(3,:),t(3,:),q ,np,np,nt);
Mq=Mq+Mq.';

%% champ lointain  = intégrale de phi^infini*(n-1)*[champ total engendré par n]
gamma=1;%exp(1i*pi/4)/sqrt(8*pi*k);%coeff 2D
u_inf=gamma*exp(-1i*k*[cos(x_c)' , sin(x_c)']*p)*Mq*u_t;
    