% operateurs possibles : '|W|', '|F1-F0|', 'W' et 'W#'
function [W, demiMasse] = operateur_mesures( F0, F1, k, anglesEmissions, anglesMesures, operateur)
GAMMA = exp(1i*pi/4)/sqrt(8*pi*k);
nEmissions = size(anglesEmissions,2);
nMesures = size(anglesMesures,2);

% Matrice de masse du produit scalaire dans L2(gamma_e) : integrale d'un
% produit de fonction P1 par morceaux sur teta1--teta2
h = abs(anglesEmissions(2:nEmissions)-anglesEmissions(1:nEmissions-1));
h = h(:);
masse = spdiags([[h/6;0] 2/6*([h;0]+[0;h]) [0;h/6]],-1:1,nEmissions,nEmissions);
%masse = speye(nEmissions)*mean(h);
demiMasse = sqrtm(full(masse));
% On fait alors le changement de variable xtilde = M1/2x et 
% Atilde = M1/2AM-1/2, et comme ici les operateurs sont de la forme
% Donnees*masse (op. integraux) le chagement de variable donne
% M1/2DonneesM1/2

% Operateur de mesures
switch operateur
    case 'W' % W=S^-1(F1-F0)
        W = demiMasse*((eye(size(F0))+2*1i*k*(GAMMA'*GAMMA)*F0*masse)\((F1-F0)*demiMasse));
    case 'W#' % W# = |re W| + |im W|
        W = demiMasse*((eye(size(F0))+2*1i*k*(GAMMA'*GAMMA)*F0*masse)\((F1-F0)*demiMasse));

        reW = (W+W')/2; % normalement = (W+W')*masse pour bien donner W+Wetoile
        [~,S,V] = svd(reW,'econ');
        absReW = V*S*V';
        
        imW = (W-W')/2i;
        [~,S,V] = svd(imW,'econ');
        absImW = V*S*V';

        W = (absReW+absImW);
    case {'|W|','|F1-F0|'}
        h = abs(anglesMesures(2:nMesures)-anglesMesures(1:nMesures-1));
        h = h(:);
        masse = spdiags([[h/6;0] 2/6*([h;0]+[0;h]) [0;h/6]],-1:1,nMesures,nMesures);
        demiMasseMesures = sqrtm(full(masse));
        W = demiMasseMesures*(F1-F0)*demiMasse;
        [~,S,V] = svd(W,'econ');
        W = V*S*V';
end
end

