% la solution de (Delta +k^2n)u_s=-k^2(n-1)h evaluée aux points p
% bb_pml=[xmin xmax ymin ymax] etant les bornes de départ de la zone pml definie dans le maillage
function U=u_s(h,k,points_de_maillage,triangles,n_x,bb_pml)

%% matrices elements finis telles que M1*u_s = -Mq*h
%% avec décomposition LU de M1 telle que P*(R\M1)*Q = L*U
[Mq,LM,UM,PM,QM,RM]=assemblage_2(points_de_maillage,triangles,n_x,k,bb_pml);

%% résolution du système en u_s
%disp('Calcul de la solution');
if isempty(QM) %on a recu un lu incomplet : gmres
    U=zeros(size(h));
    for ii=1:size(h,2)
        [U(:,ii),flag]=gmres(PM,-Mq*h(:,ii),8,1e-6,3,LM,UM); % preconditionneur lu incomplet pour donner LM et UM
    end
elseif isempty(RM)
    U=-QM*(UM\(LM\(PM*Mq*h))); %cette version de matlab n'a pas donne RM
else
    U=-QM*(UM\(LM\(PM*(RM\Mq*h)))); %la totale
end
%%
end